*株式会社ライトストーン
*Stata分析機能例題集　項目応答理論(IRT)

***バイナリIRTモデル***************************

*データセットをインポートして内容を確認
use https://www.stata-press.com/data/r16/masc1 ,clear
list in 1/5

*1PLモデルをフィット
irt 1pl q1-q9

*結果を困難度が低い項目から高い項目の順番に並べる
estat report, sort(b) byparm

*項目応答曲線（ICC）
irtgraph icc, blocation legend(off) xlabel(,alt)

*テスト特性曲線（TCC）
irtgraph tcc, scorelines(2 7)

*経験的比率を計算し、ICCに重ねる
predict Theta, latent
collapse q*, by(Theta)
irtgraph icc q1, addplot(scatter q1 Theta)

*ここまでの推定をonepとして保存
estimates store onep

*2PLモデルをフィット
use https://www.stata-press.com/data/r16/masc1, clear
irt 2pl q1-q9

*尤度比検定
lrtest onep

*項目情報関数（IIF）
irtgraph iif, legend(pos(1) col(1) ring(0))

*テスト情報関数（TIF）
irtgraph tif, se


***カテゴリカルなIRTモデル*************************

*データセットをインポートして内容を確認
use https://www.stata-press.com/data/r16/charity, clear
list in 1/5, nolabel

*順序付きの段階反応モデル（GRM）をフィット
irt grm ta1-ta5

*境界特性曲線（BCC）
irtgraph icc ta5, blocation legend(pos(11) col(1) ring(0))

*項目情報関数（CCC）
irtgraph icc ta5, xlabel(-4 -.7 .7 1.85 4, grid)

*テスト特性曲線（TCC）
irtgraph tcc, thetalines(-3/3)

*項目情報関数（IIF）
irtgraph iif, legend(pos(11) col(1) ring(0))

*テスト情報関数（TIF）
irtgraph tif, se